<?php

namespace SGalinski\SgJobs\Event\Listener;

use SGalinski\SgJobs\Service\SitemapService;
use SGalinski\SgSeo\Events\AccessPageListEvent;
use TYPO3\CMS\Core\Utility\ArrayUtility;

/**
 * Class AccessPageListEventListener
 *
 * @package SGalinski\SgJobs\Event\Listener
 */
class AccessPageListEventListener {
	/**
	 * @var SitemapService
	 */
	protected $sitemapService;

	/**
	 * AccessPageListEventListener constructor.
	 *
	 * @param SitemapService $sitemapService
	 */
	public function __construct(SitemapService $sitemapService) {
		$this->sitemapService = $sitemapService;
	}

	/**
	 * @param AccessPageListEvent $event
	 */
	public function __invoke(AccessPageListEvent $event) {
		$pageList = $event->getPageList();
		$additionalPageList = $this->sitemapService->generatePagesList(
			$event->getSysLanguageUid(), $event->getSite()->getRootPageId()
		);

		ArrayUtility::mergeRecursiveWithOverrule($pageList, $additionalPageList);
		$event->setPageList($pageList);
	}
}
